<script>
import { mapState } from 'vuex';

import * as projectsApiRoutes from '~/helpers/api-routes/projects.js';

import AdminProjectCard from '~/components/admin/project-card.vue';

export default {
  name: `admin-projects-dashboard`,
  components: { AdminProjectCard },
  props: {
    libraries: { type: Array, required: true },
    users: { type: Array, required: true },
  },
  data() {
    return {
      addingProject: false,
      newProjectName: ``,
      showInactive: false,
    }
  },
  computed: {
    ...mapState({
      projects: (state) => state.projects.projects,
      isAdmin: (state) => state.users.currentUser.roles.includes(`admin`),
    }),
    filteredProjects() {
      if (!this.projects) return [];
      if (this.showInactive) return this.projects;
      return this.projects.filter(p => p.active);
    },
  },
  methods: {
    resetNewProjectForm() {
      this.addingProject = false;
      this.newProjectName = ``;
    },
    async addProject () {
      const data = { name: this.newProjectName };
      try {
        const project = await this.$axios.$post(projectsApiRoutes.create(), data);
        this.$store.commit(`projects/addProject`, project);
      } catch (err) {
        this.$notify({ type: `error`,
                       title: this.$t(`errors.create-project.title`),
                       text: this.$t(`errors.create-project.content.${err.response.data.name}`),
                       duration: 4000, });
      }
      this.resetNewProjectForm();
    },
  },
  async created() {
    if (this.$store.state.projects.projects === null) {
      await this.$store.dispatch(`projects/loadProjects`, { $axios: this.$axios });
    }
  },
}
</script>

<template>
  <cbr-dashboard
    :title="$tc(`common.project`, 2)"
  >
    <template v-slot:title-commands>
      <div v-if="!addingProject">
        <v-row no-gutters align="center">
          <v-switch
            v-if="isAdmin"
            v-model="showInactive"
            :label="$t(`common.show-inactive`)"
            class="mr-4 my-0 py-0"
            hide-details
          />
          <v-btn
            v-if="isAdmin"
            fab
            x-small
            color="primary"
            :elevation="4"
            @click="addingProject = true"
          >
            <v-icon>mdi-plus</v-icon>
          </v-btn>
        </v-row>
      </div>
      <v-form v-else @submit.prevent="addProject">
        <v-row align="center">
          <v-text-field
            v-model="newProjectName"
            dense
            :label="$t(`common.name`)"
            type="text"
            class="mx-4"
            required
          />
          <v-btn icon type="submit">
            <v-icon>mdi-check</v-icon>
          </v-btn>
          <v-btn icon @click="resetNewProjectForm">
            <v-icon>mdi-close</v-icon>
          </v-btn>
        </v-row>
      </v-form>
    </template>
    <admin-project-card v-for="project in filteredProjects"
                        :key="project.name"
                        :project="project"
                        :projects="projects"
                        :libraries="libraries"
                        :users="users" />
  </cbr-dashboard>
</template>

<style lang="scss" scoped>
.app-admin__projects-dashboard {
  background-color: var(--dashboard-bg);
  color: var(--dashboard-color);
  border-radius: var(--border-radius);
  padding: 1em;
}

.app-admin__projects-dashboard__title {
  margin: 0;
}
</style>
